// 005 u_find_memo
// 12 jun 2005

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_bfs_02_create_table_win32;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, StdCtrls, ExtCtrls, ComCtrls, DB, SqlExpr, FMTBcd,
  DBClient, Provider, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    log_: TTabSheet;
    Memo1: TMemo;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    create_table_: TButton;
    SQLConnection1: TSQLConnection;
    drop_table_: TButton;
    list_tables_: TButton;
    SQLDataSet1: TSQLDataSet;
    DataSource1: TDataSource;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    table_name_listbox_: TListBox;
    metadata_get_tables_: TButton;
    DBGrid1: TDBGrid;
    Splitter2: TSplitter;
    insert_: TButton;
    create_course_: TButton;
    drop_course_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure list_tables_Click(Sender: TObject);
    procedure metadata_get_tables_Click(Sender: TObject);
    procedure insert_Click(Sender: TObject);
    procedure create_course_Click(Sender: TObject);
    procedure drop_course_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses DbxCommon
      , u_c_display
      ;

{$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    const
          k_planning_table_name= 'planning';
          k_create_planning=
              'CREATE TABLE '+ k_planning_table_name
            + '  (p_id INTEGER, p_city CHAR(15), p_date CHAR(10) )'; //, p_date_2 DATE )';
          k_drop_planning=
              'DROP TABLE '+ k_planning_table_name;

    procedure execute_request(p_sql_request: String);
      var l_c_dbx_transaction: tDbxTransaction;
      begin
        with Form1 do
        begin
          display('> execute');
          Try
            Try
              SqlConnection1.Open;
              l_c_dbx_transaction:= SqlConnection1.BeginTransaction;
              SqlConnection1.ExecuteDirect(p_sql_request);
              SqlConnection1.CommitFreeAndNil(l_c_dbx_transaction);
              display('  ok');
            Except
              display('  *** error');
              SqlConnection1.RollBackFreeAndNil(l_c_dbx_transaction);
            end;
          finally
            SqlConnection1.Close;
          end;
          display('< execute');
        end; // with Form1
      end; // execute_request

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        execute_request(k_create_planning);
      end; // create_table_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        execute_request(k_drop_planning);
      end; // drop_table_Click

    procedure TForm1.metadata_get_tables_Click(Sender: TObject);
      begin
        display('> list_tables');
        ClientDataset1.Close;
        SqlDataSet1.DbxCommandType:= 'Dbx.MetaData';
        SqlDataSet1.CommandText:= 'GetTables';
        ClientDataset1.Open;
        display('< list_tables');
      end; // metadata_get_tables_Click

    procedure TForm1.list_tables_Click(Sender: TObject);
      begin
        display('> list_tables');
        SqlDataSet1.Close;
        SqlDataSet1.DbxCommandType:= 'Dbx.MetaData';
        SqlDataSet1.CommandText:= 'GetTables';
        SqlDataSet1.Open;

        table_name_listbox_.Items.Clear;
        while not SqlDataSet1.Eof do
        begin
          table_name_listbox_.Items.Add(SqlDataSet1.FieldByName('TableName').AsString);
          SqlDataSet1.Next;
        end; // while not SqlDataSet1.Eof
        display('< list_tables');
      end; // list_tables_Click

    const k_insert_course=
        'INSERT INTO '+ k_planning_table_name
      + '  (p_id, p_date_2)'
      + '  VALUES (10, 9/2/2007 )';

    procedure TForm1.insert_Click(Sender: TObject);
      begin
        execute_request(k_insert_course);
      end; // insert_Click

    // -- added in order to create / drop COURSE

    const
          k_course_table_name= 'course';
          k_create_course=
              'CREATE TABLE '+ k_course_table_name
            + '  (c_id INTEGER, c_course_name CHAR(27), c_days INTEGER, c_price NUMERIC(12, 2))';
          k_drop_course=
              'DROP TABLE '+ k_course_table_name;

    procedure TForm1.create_course_Click(Sender: TObject);
      begin
        execute_request(k_create_course);
      end; // create_course_Click

    procedure TForm1.drop_course_Click(Sender: TObject);
      begin
        execute_request(k_drop_course);
      end; // drop_course_Click



end.
